#!/bin/sh

# This file configuring and start Wireless client mode and connect to AP

# Command line arguments:
#   $1 interface name

#############################
#########  Params  ##########
#############################

INTERFACE="$1"
FORCE="$2"

#############################
######### Functions #########
#############################


print_help()
{
echo "
This file disconnect wifi

Command line arguments:
  $1 interface name
"
}

#############################
#########  Script  ##########
#############################

#Print help
if [ "$1" == "--help" ]; then
    print_help
    exit 1
fi

#Check input params
if [ $# -lt 1 ]; then
    echo "Not enough params!" >&2
    print_help    
    exit 1
fi

echo "Script wifi_disconnect.sh" >&2
if [ "$FORCE" != "force" ] && [ -e "/tmp/switch_cloud" ] ; then
    echo "beacause switch cloud , no call the wifi disconnect!"
    exit 0
fi

#Set interface down - instead of reset all network interfaces - this restart only one interface
ip link set dev $INTERFACE down

#Stop udhcpd
killall udhcpd

#Stop udhcpc
killall udhcpc
if [ -e "/var/run/dhclient.$INTERFACE.pid" ] ; then
    kill -9 $(cat /var/run/dhclient.$INTERFACE.pid)
    rm /var/run/dhclient.$INTERFACE.pid
    rm -f /var/lib/dhcp/dhclient.leases
fi

#Stop hostapd
killall hostapd

#Stop wpa_supplicant
killall wpa_supplicant

#remove IPv4 address (it should do before DHCP client or any changing IP address)
ifconfig $INTERFACE 0

#Set interface up - instead of reset all network interfaces - this restart only one interface
ip link set dev $INTERFACE up

exit 0
