#!/bin/sh

#export PATH=$PATH:/wpa
#export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/mnt/flash/lumi_ipc
#WIFI_CONF_FILE="/wpa/wifi.conf"
WIFI_CONF_FILE="/home/root/router_ssid"
WPA_SUPPLICANT_CONFIG_FILE="/etc/wpa_supplicant.conf"
#DEVICE_CONFIG_FILE="/wpa/device.conf"

wifimode=""

update_wpa_conf()
{
    if [ x"$2" = x ]; then
    cat <<EOF > $WPA_SUPPLICANT_CONFIG_FILE
ctrl_interface=/var/run/wpa_supplicant
update_config=1

network={
        ssid="$1"
        key_mgmt=open
}
EOF
    else
    cat <<EOF > $WPA_SUPPLICANT_CONFIG_FILE
ctrl_interface=/var/run/wpa_supplicant
update_config=1

network={
        ssid="$1"
        psk="$2"
        key_mgmt=WPA-PSK
		proto=WPA WPA2
}
EOF
    fi
}

wifi_ap_mode()
{
    # AP mode

#	wifimode=`iwconfig wlan0 | grep Mode | cut -d ':' -f 2 | cut -d ' ' -f 1`
#    if [ "$wifimode" = "Master" ]; then
#	echo "Already in AP mode"
#	return
#   fi

	ifconfig wlan0 down
	killall udhcpc wpa_supplicant hostapd dhcpd
	ifconfig wlan0 up

	ifconfig wlan0 192.168.1.1 netmask 255.255.255.0
	#mount -t tmpfs -o mode=0755 tmpfs /var
	mkdir -p /var/run/hostapd
	/wpa/hostapd /wpa/hostapd.conf -ddB

	mkdir -p /var/lib/dhcp
	touch /var/lib/dhcp/dhcpd.leases
	#dhcpd wlan0 -cf /etc/dhcp/dhcpd.conf -lf /var/lib/dhcp/dhcpd.leases
	udhcpd /wpa/udhcpd.conf &
}

wifi_sta_mode()
{
#	wifimode=`iwconfig wlan0 | grep Mode | cut -d ':' -f 2 | cut -d ' ' -f 1`
#    if [ "$wifimode" = "Managed" ]; then
#
#		# check if we've got ip
#		ifconfig wlan0 | grep "inet addr"
#		if [ "$?" = "0" ]; then
#			echo "Already in STA mode & have ip"
#			return $?
#		fi
#		
#    	# STA mode
#		echo "Enabling wifi STA mode"
#    fi

    get_ssid_passwd
    echo $ssid $passwd
    update_wpa_conf $ssid $passwd

    ifconfig wlan0 down
    killall udhcpc wpa_supplicant hostapd dhcpd
    #mount -t tmpfs -o mode=0755 tmpfs /var
    ifconfig wlan0 up
    iwconfig wlan0 mode Managed
    mkdir -p /var/run/wpa_supplicant
    #wpa_supplicant -Dwext -iwlan0 -c $WPA_SUPPLICANT_CONFIG_FILE -B
    wpa_supplicant  -D  nl80211  -i  wlan0  -c /etc/wpa_supplicant.conf   -B

    #udhcpc -i wlan0 -s /wpa/simple.script
    udhcpc -i wlan0

    # check if we've got ip
	echo "get ip addr :"
    ifconfig wlan0 | grep "inet addr" | cut -d ':' -f 2 |cut -d ' ' -f 1
}

get_ssid_passwd()
{
    STRING=`cat $WIFI_CONF_FILE | grep -v ^#`
    key_mgmt=${STRING##*key_mgmt=}
    if [ $key_mgmt == "NONE" ]; then
	passwd=""

	ssid=${STRING##*ssid=\"}
	ssid=${ssid%%\"*}
    else
	passwd=${STRING##*psk=\"}
	passwd=${passwd%%\"*}

	ssid=${STRING##*ssid=\"}
	ssid=${ssid%%\"*}
    fi
}


start()
{
    if [ -e $WIFI_CONF_FILE ]; then
	wifi_sta_mode
    else
	wifi_ap_mode
    fi
}

start
